﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Lobs.ApplicationModel;
using Lobs.DataModel;
using Lobs.DataModel.AccessDataProvider;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace ApplicationModelTests
{
  /// <summary>
  /// Summary description for UnitTest1
  /// </summary>
  [TestClass]
  public class InitializationTests
  {
    public InitializationTests()
    {}

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get{return _testContextInstance;}
      set{_testContextInstance = value;}
    }
    private TestContext _testContextInstance;

    // Use ClassInitialize to run code before running the first test in the class
    [ClassInitialize]
    public static void MyClassInitialize(TestContext testContext)
    {
      GlobalSetups.InitializeApplication(testContext);
    }

    // Use ClassCleanup to run code after all tests in a class have run
    [ClassCleanup]
    public static void MyClassCleanup()
    {
     GlobalSetups.DeinitializeApplication();
    }

    // Use TestInitialize to run code before running each test 
    // [TestInitialize()]
    // public void MyTestInitialize() { }
    //
    // Use TestCleanup to run code after each test has run
    // [TestCleanup()]
    // public void MyTestCleanup() { }
    //

    [TestMethod]
    public void Initialize_key_tables()
    {
      var process = ApplicationProcess.Current;
      process.InitializeKeyTables();

      var categories = process.KeyTables.Cagegories;
      Assert.AreEqual(categories.Count(), 8);

      var shippers = process.KeyTables.Shippers;
      Assert.AreEqual(shippers.Count(), 3);
    }
  }
}
