﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lobs.ApplicationModel
{
  /// <summary>
  /// 
  /// </summary>
  public class Employee //: BaseClass
  {
    public string LastName { get; set; }

    public string FirstName { get; set; }

    public string TitleOfCourtesy { get; set; }

    public string Title { get; set; }

    public byte[] Photo { get; set; }

    // etc...

    /// <summary>
    /// Load photo of this employee.
    /// </summary>
    public void LoadPhoto()
    {
      if (Photo == null)
      {
        // Load from data provider
        var data = ApplicationProcess.Current.DataProvider.LoadEmployeePhoto(DataEmployee.ID);
        Photo = data;
      }
    }

    /// <summary>
    /// Creates Employee or Manager from data model object.
    /// </summary>
    internal static Employee FromDataModel(DataModel.Employee dataEmployee)
    {
      // Create empolyee or manager
      Employee employee = dataEmployee.IsManager ? new Manager() : new Employee();
      employee.DataEmployee = dataEmployee;

      //employee.BaseFromDataModel(dataEmployee);
      employee.LastName = dataEmployee.LastName;
      employee.FirstName = dataEmployee.FirstName;
      employee.TitleOfCourtesy = dataEmployee.TitleOfCourtesy;
      employee.Title = dataEmployee.Title;
      employee.Photo = dataEmployee.Photo;
      return employee;
    }

    /// <summary>
    /// Copies properties to data model.
    /// </summary>
    internal DataModel.Employee ToDataModel()
    {
      if (DataEmployee == null)
        DataEmployee = new DataModel.Employee();

      //BaseToDataModel(DataEmployee);
      DataEmployee.LastName = LastName;
      DataEmployee.FirstName = FirstName;
      DataEmployee.TitleOfCourtesy = TitleOfCourtesy;
      DataEmployee.Title = Title;
      DataEmployee.Photo = Photo;

      return DataEmployee;
    }

    internal DataModel.Employee DataEmployee { get; set; }
  }
}
