﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lobs.DataModel
{
  public interface IDataProvider
  {
    // Keytables
    IEnumerable<Category> LoadCategories();
    IEnumerable<Shipper> LoadShippers();


    // Employee
    IEnumerable<Employee> LoadEmployees();
    byte[] LoadEmployeePhoto(string id);
    void SaveEmployee(Employee employee);
    void DeleteEmployee(Employee employee);
    int SaveEmployees(IEnumerable<Employee> employees);

    // Product
    IEnumerable<Product> LoadProducts();
    void SaveProduct(Product product);

    // etc.
  }
}
