﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Lobs;
using Lobs.DataModel;
using Lobs.DataModel.AccessDataProvider;

namespace AccessDataProviderTests
{
  /// <summary>
  /// Summary description for UnitTest1
  /// </summary>
  [TestClass]
  public class EmployeeTests
  {
    public EmployeeTests()
    { }

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get { return _testContextInstance; }
      set { _testContextInstance = value; }
    }
    TestContext _testContextInstance;

    // Use ClassInitialize to run code before running the first test in the class
    [ClassInitialize]
    public static void MyClassInitialize(TestContext testContext)
    {
      _provider = GlobalSetups.InitializeProvider(testContext);
    }

    // Use ClassCleanup to run code after all tests in a class have run
    [ClassCleanup]
    public static void MyClassCleanup()
    {
      GlobalSetups.DeinitializeProvider(_provider);
    }

    static IDataProvider _provider;

    // Use TestInitialize to run code before running each test 
    // [TestInitialize()]
    // public void MyTestInitialize() { }
    //
    // Use TestCleanup to run code after each test has run
    // [TestCleanup()]
    // public void MyTestCleanup() { }

    [TestMethod]
    public void Load_all_employees()
    {
      var employees = _provider.LoadEmployees();

      var list = new List<Employee>();
      list.AddRange(employees);

      Assert.AreEqual(list.Count, 9);
    }

    [TestMethod]
    public void Load_employees_photos()
    {
      var employees = _provider.LoadEmployees();

      foreach (var employee in employees)
      {
        var photo = _provider.LoadEmployeePhoto(employee.ID);
        Assert.IsTrue(photo.Length > 0);
      }
    }
  }
}