﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Lobs;
using Lobs.DataModel;
using Lobs.DataModel.AccessDataProvider;

namespace AccessDataProviderTests
{
  /// <summary>
  /// Summary description for UnitTest1
  /// </summary>
  [TestClass]
  public class NorthWindTests
  {
    public NorthWindTests()
    {
      //
      // TODO: Add constructor logic here
      //
    }

    TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get { return testContextInstance; }
      set { testContextInstance = value; }
    }

    // Use ClassInitialize to run code before running the first test in the class
    [ClassInitialize()]
    public static void MyClassInitialize(TestContext testContext)
    {
      _provider = MSAccessProvider.CreateDataProvider(null);
      _provider.Initialize();
    }

    // Use ClassCleanup to run code after all tests in a class have run
    [ClassCleanup()]
    public static void MyClassCleanup()
    {
      _provider.Deinitialize();
      _provider = null;
    }

    static IDataProvider _provider;


    // Use TestInitialize to run code before running each test 
    // [TestInitialize()]
    // public void MyTestInitialize() { }
    //
    // Use TestCleanup to run code after each test has run
    // [TestCleanup()]
    // public void MyTestCleanup() { }

    [TestMethod]
    public void Load_categories()
    {
      var categories = _provider.LoadCategories();
      int count = categories.Count();

      Assert.AreEqual(count, 8);
    }

    [TestMethod]
    public void Load_shippers()
    {
      var shippers = _provider.LoadShippers();
      int count = shippers.Count();

      Assert.AreEqual(count, 3);
    }

    [TestMethod]
    public void Load_all_employees()
    {
      var employees = _provider.LoadEmployees();

      var list = new List<Employee>();
      list.AddRange(employees);

      Assert.AreEqual(list.Count, 9);
    }
  }
}