﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;

namespace Lobs.ViewModel
{
  /// <summary>
  /// Base class for all ViewModel classes in this LOB application.
  /// </summary>
  public class ViewModelBase : Frmwrk.Windows.ViewModel.ViewModelBase
  {
    static ViewModelBase()
    {
      _uiSyncContext = SynchronizationContext.Current;
      Debug.Assert(_uiSyncContext != null);
    }

    static readonly SynchronizationContext _uiSyncContext;

    /// <summary>
    /// Gets the current application process.
    /// </summary>
    protected ApplicationModel.ApplicationProcess ApplicationProcess
    {
      get { return ApplicationModel.ApplicationProcess.Current; }
    }

    /// <summary>
    /// Invokes the specified action in the context of the UI thread.
    /// </summary>
    protected void SendToView(Action action)
    {
      _uiSyncContext.Send(state => action(), null);
    }
  }
}
