﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using Frmwrk.Collections.ObjectModel;
using Frmwrk.ComponentModel;
using Frmwrk.Windows.ViewModel;
using Lobs.ApplicationModel;


namespace Lobs.ViewModel
{
  /// <summary>
  /// Basic singleton of all view model objects.
  /// </summary>
  public class ViewModelProcess : ViewModelBase
  {
    /// <summary>
    /// Initializes a new instance of the <see cref="ViewModelProcess"/> class.
    /// </summary>
    ViewModelProcess()
    {
      // Preload key tables
      var service = new AsyncServiceAction(ApplicationProcess.InitializeKeyTables);
      service.ServiceCompleted += (sender, e) => { };
      service.InvokeServiceAsync();
    }

    /// <summary>
    /// Initializes the single ViewModelProcess.
    /// </summary>
    public static void Initialize()
    {
      if (_viewModelProcess != null)
        throw new InvalidOperationException("Only one ViewModelProcess must exist.");
      _viewModelProcess = new ViewModelProcess();

      _viewModelProcess.MainWindow = new MainViewModel();

      //#if SILVERLIGHT
      //     Application.Current.RootVisual = new MainPage();
      //#else
      //      var mainWindow = new WpfSample.MainWindow();
      //      mainWindow.DataContext = _viewModelProcess;
      //      mainWindow.Show();
      //#endif
    }

    public MainViewModel MainWindow { get; set; }

    /// <summary>
    /// The current instance of ViewModelProcess.
    /// </summary>
    public static ViewModelProcess Current
    {
      get
      {
#if SILVERLIGHT
        // To prevent crash of Expression Blend check IsInDesignTool
        Debug.Assert(DesignerProperties.IsInDesignTool || _viewModelProcess != null);
#endif
        return _viewModelProcess;
      }
    }
    static ViewModelProcess _viewModelProcess;

    ///// <summary>
    ///// The spend overview reeport.
    ///// </summary>
    //public SpendOverviewReport SpendOverviewReport
    //{
    //  get
    //  {
    //    if (_spendOverviewReport == null)
    //      _spendOverviewReport = new SpendOverviewReport();
    //    return _spendOverviewReport;
    //  }
    //}
    //private SpendOverviewReport _spendOverviewReport;

    ///// <summary>
    ///// Gets or sets the current content page.
    ///// </summary>
    ///// <value>The current content page.</value>
    //public ProPageBase CurrentContentPage { get; set; }

    //internal void LoadEmployees(ObservableCollection<Employee> collection)
    //{
    //  //var list = ApplicationProcess.Current.LoadEmployees();

    //  var process = ApplicationProcess.Current;
    //  var service = new AsyncServiceFunction<List<ApplicationModel.Employee>>(process.LoadEmployees);
    //  service.ServiceCompleted += LoadEmployeesCompleted;
    //  service.InvokeServiceAsync(collection);
    //}

    //void LoadEmployeesCompleted(object sender, AsyncServiceCompletedEventArgs<List<ApplicationModel.Employee>> e)
    //{
    //  ObservableCollection<Employee> collection = (ObservableCollection<Employee>)e.UserState;
    //  foreach (var item in e.Result)
    //  {
    //    collection.Add(Employee.FromApplicationModel(item));
    //  }
    //}
  }
}
