﻿Imports System.Windows.Media.Imaging
Imports Lobs
Imports System.Linq.Expressions
Imports System.Reflection
Imports System.Windows.Media
Imports System.IO

Namespace Lobs.ViewModel
  Public Class Employee
    Inherits ViewModelBase

    Public Sub New()
    End Sub

    Public Property FirstName() As String
      Get
        Return Me._FirstName
      End Get
      Set(ByVal value As String)
        If (Me._FirstName <> value) Then
          Me._FirstName = value
          MyBase.RaisePropertyChanged(Function() FirstName)
          MyBase.RaisePropertyChanged(Function() FullName)
        End If
      End Set
    End Property
    Private _FirstName As String

    Public Property LastName() As String
      Get
        Return Me._LastName
      End Get
      Set(ByVal value As String)
        If (Me._LastName <> value) Then
          Me._LastName = value
          MyBase.RaisePropertyChanged(Function() LastName)
          MyBase.RaisePropertyChanged(Function() FullName)
        End If
      End Set
    End Property
    Private _LastName As String

    Public ReadOnly Property FullName() As String
      Get
        Return String.Format("{0} {1} {2}", Me.TitleOfCourtesy, Me.FirstName, Me.LastName)
      End Get
    End Property

    Public Property Photo() As ImageSource
      Get
        Return Me._Photo
      End Get
      Set(ByVal value As ImageSource)
        If (Not Me._Photo Is value) Then
          Me._Photo = value
          MyBase.RaisePropertyChanged(Function() Photo)
        End If
      End Set
    End Property
    Private _Photo As ImageSource

    Public Property PhotoBytes() As Byte()
      Get
        Return Me._PhotoBytes
      End Get
      Set(ByVal value As Byte())
        Me._PhotoBytes = value
#If SILVERLIGHT = 0 Then
        Dim encoder As New JpegBitmapDecoder(New MemoryStream(value), BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.Default)
        Me.Photo = encoder.Frames.Item(0)
#Else
        Dim bm = New BitmapImage()
        bm.SetSource(New MemoryStream(value))
        Photo = bm
#End If
      End Set
    End Property
    Private _PhotoBytes As Byte()


    Public Property Title() As String
      Get
        Return Me._Title
      End Get
      Set(ByVal value As String)
        If (Me._Title <> value) Then
          Me._Title = value
          MyBase.RaisePropertyChanged(Function() Title)
        End If
      End Set
    End Property
    Private _Title As String


    Public Property TitleOfCourtesy() As String
      Get
        Return Me._TitleOfCourtesy
      End Get
      Set(ByVal value As String)
        If (Me._TitleOfCourtesy <> value) Then
          Me._TitleOfCourtesy = value
          MyBase.RaisePropertyChanged(Function() TitleOfCourtesy)
          MyBase.RaisePropertyChanged(Function() FullName)
        End If
      End Set
    End Property
    Private _TitleOfCourtesy As String


    Public Shared Function FromApplicationModel(ByVal amEmployee As ApplicationModel.Employee) As Employee
      Dim employee As New Employee
      employee.AppEmployee = amEmployee
      employee.LastName = amEmployee.LastName
      employee.FirstName = amEmployee.FirstName
      employee.TitleOfCourtesy = amEmployee.TitleOfCourtesy
      employee.Title = amEmployee.Title
      If (Not amEmployee.Photo Is Nothing) Then
        employee.PhotoBytes = amEmployee.Photo
      End If
      Return employee
    End Function

    Public Function ToApplicationModel() As ApplicationModel.Employee
      If (Me.AppEmployee Is Nothing) Then
        Me.AppEmployee = New ApplicationModel.Employee
      End If
      Me.AppEmployee.LastName = Me.LastName
      Me.AppEmployee.FirstName = Me.FirstName
      Me.AppEmployee.Title = Me.Title
      Me.AppEmployee.TitleOfCourtesy = Me.TitleOfCourtesy
      Return Me.AppEmployee
    End Function

    Friend Property AppEmployee() As ApplicationModel.Employee
      Get
        Return _AppEmployee
      End Get
      Set(ByVal value As ApplicationModel.Employee)
        _AppEmployee = value
      End Set
    End Property
    Private _AppEmployee As ApplicationModel.Employee

  End Class
End Namespace