﻿Imports Lobs
Imports System.Windows
Imports System.Collections.ObjectModel
Imports Frmwrk.ComponentModel
Imports Lobs.Views

Namespace Lobs.ViewModel
  Public Class ProductDialogModel
    Inherits ViewModelBase

    Public Sub New()
      Me._products = New ObservableCollection(Of Product)
    End Sub

#If SILVERLIGHT = 0 Then
    Friend Function CreateView(ByVal owner As Window) As ProductDialog
      Me.View = New ProductDialog
      Me.View.Owner = owner
      Me.View.DataContext = Me
      Me.LoadProducts()
      Return Me.View
    End Function
#Else
    Friend Function CreateView() As ProductDialog
      Me.View = New ProductDialog
      Me.View.DataContext = Me
      Me.LoadProducts()
      Return Me.View
    End Function
#End If

    Friend Sub LoadProducts()
      Dim service As New AsyncServiceFunction(Of List(Of ApplicationModel.Product))(New Func(Of List(Of ApplicationModel.Product))(AddressOf MyBase.ApplicationProcess.LoadProducts))
      AddHandler service.ServiceCompleted, AddressOf LoadProductsCompleted
      service.InvokeServiceAsync()
    End Sub

    Function LoadProductsCompleted(ByVal sender1 As Object, ByVal e1 As AsyncServiceCompletedEventArgs(Of List(Of ApplicationModel.Product)))
      Dim item As ApplicationModel.Product
      For Each item In e1.Result
        Me._products.Add(Product.FromApplicationModel(item))
      Next
      Return True
    End Function

    Public ReadOnly Property Products() As ObservableCollection(Of Product)
      Get
        Return Me._products
      End Get
    End Property

    Private Property View() As ProductDialog
      Get
        Return _view
      End Get
      Set(ByVal value As ProductDialog)
        _view = value
      End Set
    End Property
    Private _view As ProductDialog

    Private ReadOnly _products As ObservableCollection(Of Product)
  End Class
End Namespace