﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using Lobs.DataModel.AccessDataProvider;

namespace Lobs.WcsService
{
  [ServiceContract(Namespace = "")]
  [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
  public class Service2 : DataModel.IDataProvider
  {
    static Service2()
    {
      Config.Initialize();
      _dataprovider = DataModel.DataProviderFactory.GetProvider("access");
    }

    static readonly DataModel.IDataProvider _dataprovider;

    [OperationContract]
    public IEnumerable<DataModel.Category> LoadCategories()
    {
      return _dataprovider.LoadCategories();
    }

    [OperationContract]
    public IEnumerable<DataModel.Shipper> LoadShippers()
    {
      return _dataprovider.LoadShippers();
    }

    [OperationContract]
    public IEnumerable<DataModel.Employee> LoadEmployees()
    {
      return _dataprovider.LoadEmployees();
    }

    [OperationContract]
    public byte[] LoadEmployeePhoto(string id)
    {
      return _dataprovider.LoadEmployeePhoto(id);
    }

    [OperationContract]
    public void SaveEmployee(DataModel.Employee employee)
    {
      _dataprovider.SaveEmployee(employee);
    }

    [OperationContract]
    public void DeleteEmployee(DataModel.Employee employee)
    {
      _dataprovider.DeleteEmployee(employee);
    }

    [OperationContract]
    public int SaveEmployees(IEnumerable<DataModel.Employee> employees)
    {
      return _dataprovider.SaveEmployees(employees);
    }

    [OperationContract]
    public IEnumerable<Lobs.DataModel.Product> LoadProducts()
    {
      return _dataprovider.LoadProducts();
    }

    [OperationContract]
    public void SaveProduct(Lobs.DataModel.Product product)
    {
      throw new NotImplementedException();
    }

  }
}
