﻿Imports System.ComponentModel
Imports Frmwrk.ComponentModel
Imports Lobs.DataModel
Imports ServiceReference2

Public Class WcfDataProvider
  Implements IDataProvider

  ' Methods
  Public Sub New(ByVal parameter As String)

  End Sub
  Public Shared Function CreateDataProvider() As WcfDataProvider
    Return New WcfDataProvider(Nothing)
  End Function

  Public Sub DeleteEmployee(ByVal employee As Employee) Implements IDataProvider.DeleteEmployee
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of AsyncCompletedEventArgs)
    AddHandler client.DeleteEmployeeCompleted, New EventHandler(Of AsyncCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.DeleteEmployeeAsync(employee, syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
  End Sub

  Public Function LoadCategories() As IEnumerable(Of Category) Implements IDataProvider.LoadCategories
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of LoadCategoriesCompletedEventArgs)
    AddHandler client.LoadCategoriesCompleted, New EventHandler(Of LoadCategoriesCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.LoadCategoriesAsync(syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Function LoadEmployeePhoto(ByVal id As String) As Byte() Implements IDataProvider.LoadEmployeePhoto
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of LoadEmployeePhotoCompletedEventArgs)
    AddHandler client.LoadEmployeePhotoCompleted, New EventHandler(Of LoadEmployeePhotoCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.LoadEmployeePhotoAsync(id, syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Function LoadEmployees() As IEnumerable(Of Employee) Implements IDataProvider.LoadEmployees
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of LoadEmployeesCompletedEventArgs)
    AddHandler client.LoadEmployeesCompleted, New EventHandler(Of LoadEmployeesCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.LoadEmployeesAsync(syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Function LoadProducts() As IEnumerable(Of Product) Implements IDataProvider.LoadProducts
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of LoadProductsCompletedEventArgs)
    AddHandler client.LoadProductsCompleted, New EventHandler(Of LoadProductsCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.LoadProductsAsync(syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Function LoadShippers() As IEnumerable(Of Shipper) Implements IDataProvider.LoadShippers
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of LoadShippersCompletedEventArgs)
    AddHandler client.LoadShippersCompleted, New EventHandler(Of LoadShippersCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.LoadShippersAsync(syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Sub SaveEmployee(ByVal employee As Employee) Implements IDataProvider.SaveEmployee
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of AsyncCompletedEventArgs)
    AddHandler client.SaveEmployeeCompleted, New EventHandler(Of AsyncCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.SaveEmployeeAsync(employee, syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
  End Sub

  Public Function SaveEmployees(ByVal employees As IEnumerable(Of Employee)) As Integer Implements IDataProvider.SaveEmployees
    Dim list As New List(Of Employee)
    list.AddRange(employees)
    Dim client As New Service2Client
    Dim syncHelper As New SyncCallHelper(Of SaveEmployeesCompletedEventArgs)
    AddHandler client.SaveEmployeesCompleted, New EventHandler(Of SaveEmployeesCompletedEventArgs)(AddressOf syncHelper.OnCompleted)
    client.SaveEmployeesAsync(list, syncHelper)
    syncHelper.WaitUntilSuccesOrFail()
    Return syncHelper.EventArgs.Result
  End Function

  Public Sub SaveProduct(ByVal product As Product) Implements IDataProvider.SaveProduct
    Throw New NotImplementedException
  End Sub
End Class
